%{
/* Copyright (C) 1998-1999 Kimmo.palin@helsinki.fi
   License: see COPYING
*/
#include"ttk91vm.h"
#include"mem_access.h"
#include"compiler.h"
#include"cpu.h"

#include<stdio.h>
#define YYDEBUG 1


bit32 progcount=0;
bit32 memlimit=0;

/*Konekielinen komento kehittyy tnne*/
memunit comm;
%}

%union {
	int code;
	char *symstr;
}

%token <code> OPER
%token <code> REG
%token <code> NUMLIT
%token <code> OPERNOP
%token <code> OPERADDR
%token <code> OPERJUMP
%token <code> OPERPOP
%token <code> PSEUDOP
%token <symstr> SYMSTR
%token SUMPC  /* +-merkki joka tarkoittaa hyppy eteenpin n-paikkaa.
		 Undocumented feature. Koksissa on. */

%type <code> ADDR

%%
input: 	/*empty*/
	| input line
;


ADDR:	NUMLIT		{ $$=$1;}
	| SYMSTR	{ $$=(bit16)get_symbol($1,progcount); }
;

POINT:	PSTORE
	| '=' ADDR '(' REG ')'	{ comm.flds.mem=0;comm.flds.addr=(bit16)$2;
			comm.flds.ri=$4; }
	| '=' ADDR	{ comm.flds.mem=0;comm.flds.addr=(bit16)$2;
			comm.flds.ri=0 }
	| REG	{  comm.flds.mem=0;comm.flds.addr=0;
			comm.flds.ri=$1;  }
;
PSTORE:	ADDR	{ comm.flds.mem=1;comm.flds.addr=(bit16)$1;
			comm.flds.ri=0; }
	| '@' REG	{ comm.flds.mem=1;comm.flds.addr=0;comm.flds.ri=$2; }
	| '@' ADDR	{ comm.flds.mem=2;comm.flds.addr=(bit16)$2;
			comm.flds.ri=0; }
	| ADDR '(' REG ')'	{ comm.flds.mem=1;comm.flds.addr=(bit16)$1;
			comm.flds.ri=$3; }
	| '@' ADDR '(' REG ')'	{ comm.flds.mem=2;comm.flds.addr=(bit16)$2;
			comm.flds.ri=$4; }
;


line: 	'\n'
	| OPER REG ',' POINT  '\n'{ comm.flds.opcode=(bit8)$1;comm.flds.rj=$2;
		setMem(boot_cpu,progcount++,comm); }
	| OPERADDR REG ',' PSTORE '\n' { 
		comm.flds.opcode=(bit8)$1;comm.flds.rj=$2;
		setMem(boot_cpu,progcount++,comm); }

	/*It's not a bug, it's a feature! Jos thn laittaa
	Symbolisen nimen niin koko homma on sekaisin */
	| OPERADDR REG ',' SUMPC ADDR '\n' { 
		comm.flds.opcode=(bit8)$1;comm.flds.rj=$2;
		comm.flds.ri=0;
		comm.flds.addr=$5+(bit16)progcount;
		setMem(boot_cpu,progcount++,comm); }

	| OPERPOP REG ',' REG '\n' { comm.flds.opcode=(bit8)$1;
			comm.flds.rj=$2;comm.flds.ri=$4;
			comm.flds.mem=0;comm.flds.addr=0;
			setMem(boot_cpu,progcount++,comm); }
	| OPERNOP '\n'	{ comm.flds.opcode=$1;
			setMem(boot_cpu,progcount++,comm); }
	| OPERJUMP PSTORE '\n'	{ comm.flds.rj=0; comm.flds.opcode=$1;
				setMem(boot_cpu,progcount++,comm);}
	| OPERJUMP SUMPC ADDR '\n'	{ comm.flds.rj=0;comm.flds.ri=0;
				comm.flds.mem=1;comm.flds.opcode=$1;
				comm.flds.addr=(bit16)($3+progcount);
				setMem(boot_cpu,progcount++,comm);}
	| SYMSTR PSEUDOP NUMLIT	'\n' { add_symbol($1,$2, $3,line_count); }
		/*Jos tiedoston 1. label on yksinn ekalla rivill*/
	| SYMSTR line 	{ add_symbol($1,SYMADDR, (progcount>0?
						progcount-1:0),line_count); }
;


%%






