%{
/* Copyright (C) 1998-1999 Kimmo.palin@helsinki.fi
   License: see COPYING
*/
#include<stdio.h>

#include"y.tab.h"
#include"ttk91vm.h"
#include"compiler.h"
#include"cpu.h"	/*FP/SP REG*/

unsigned int line_count=1;
%}

%%
NOP	{ yylval.code=NOP; return OPERNOP; }

LOAD	{ yylval.code=LOAD; return OPER; }
IN	{ yylval.code=IN; return OPER; }
OUT	{ yylval.code=OUT; return OPER;}
ADD	{ yylval.code=ADD; return OPER; }
SUB	{ yylval.code=SUB; return OPER; }
MUL	{ yylval.code=MUL; return OPER;}
DIV	{ yylval.code=DIV; return OPER; }
MOD	{ yylval.code=MOD; return OPER; }
AND	{ yylval.code=AND; return OPER; }
OR	{ yylval.code=OR; return OPER; }
XOR	{ yylval.code=XOR; return OPER; }
SHL	{ yylval.code=SHL; return OPER; }
SHR	{ yylval.code=SHR; return OPER; }
COMP	{ yylval.code=COMP; return OPER; }
EXIT	{ yylval.code=EXIT; return OPER; }
PUSH	{ yylval.code=PUSH; return OPER; }
SVC	{ yylval.code=SVC; return OPER; }

STORE	{ yylval.code=STORE; return OPERADDR; }
JNEG	{ yylval.code=JNEG; return OPERADDR; }
JPOS	{ yylval.code=JPOS; return OPERADDR; }
JNNEG	{ yylval.code=JNNEG; return OPERADDR; }
JNZER	{ yylval.code=JNZER; return OPERADDR; }
JNPOS	{ yylval.code=JNPOS; return OPERADDR; }
CALL	{ yylval.code=CALL; return OPERADDR; }

JUMP	{ yylval.code=JUMP; return OPERJUMP; }
JLES	{ yylval.code=JLES; return OPERJUMP; }
JEQU	{ yylval.code=JEQU; return OPERJUMP; }
JGRE	{ yylval.code=JGRE; return OPERJUMP; }
JNLES	{ yylval.code=JNLES; return OPERJUMP; }
JNEQU	{ yylval.code=JNEQU; return OPERJUMP; }
JNGRE	{ yylval.code=JNGRE; return OPERJUMP; }

POP	{ yylval.code=POP; return OPERPOP; }
IRET	{ yylval.code=IRET; return OPERNOP; /*Ksittmtn*/}

EQU	{ yylval.code=SYMEQU; return PSEUDOP; }
DC	{ yylval.code=SYMDCONST; return PSEUDOP; }
DS	{ yylval.code=SYMDSEQ; return PSEUDOP; }


R[[:digit:]]	{ yylval.code=yytext[1]-'0'; return REG; }
SP	{ yylval.code=SPREG; return REG; }
FP	{ yylval.code=FPREG; return REG; }

[-+[:digit:]][[:digit:]]*	{ yylval.code=atoi(yytext); return NUMLIT; }
[[:alpha:]_][[:alnum:]_]* { 	yylval.symstr=(char*)malloc(strlen(yytext));
			strcpy(yylval.symstr,yytext);
			return SYMSTR; }

","|"="|"@"|"("|")"	{ return yytext[0]; }

"*+"		 { return SUMPC; }

"\n"			{ line_count++; return yytext[0]; }

";"[^\n]*	  /* Eat comments */

[[:blank:]]

%%

/*
int yywrap() { return 0; }
*/

int yyerror(char *s)
{
  char errMesg[256];

  sprintf(errMesg,"Virhe rivill %d!\n%s",line_count,s);
  err_message(errMesg);

  return -1;
}

void reset_lexer(FILE *fh)
{
  yyrestart(fh);
}
